Page MenuHomePhabricator

Simpler process for Phabricator project creation
Closed, ResolvedPublic

Description

Our process to create new projects should be simpler, according to at least @Jdlrobson, @GWicke, @Deskana and probably others that have taken shortcuts knowingly or not.

The reasons behind the current workflow are basically:

  • While creating projects is easy, confusing users with overlapping, poorly worded, undescribed, etc, projects is very easy as well. It is good to have basic quality requirements and a general overview of the existing projects.
  • Cleaning up the mess created by problematic projects is not easy, and usually it's ungrateful work done not by the ones who created the problematic projects.
  • Phabricator doesn't have a way to watch new projects being created (cf. T85183).

An alternative:

  • Anybody in Project-Admins can create any type of projects without prior discussion except Tag projects (tags are usually not urgent, and they are the potentially contentious).
  • New projects must be announced via creating a dedicated task in the project "Project-Creators" (Sprint and Release projects are exempt). After someone created the project, the person changes the status of the dedicated task to "resolved".
  • Quality criteria remain the same (naming, description, etc).
  • If a project is missing quality requirements or found problematic, a task can be created assigned to the creator of the project, describing what is missing. The project could be archived until its situation is clarified.
  • If a project creator perseveres creating problematic projects, their Project-Admins membership may be revoked.

This is nothing else than the wiki principles applied to Phabricator project creation.

Event Timeline

Qgil created this task.Apr 27 2015, 10:17 AM
Qgil raised the priority of this task from to Needs Triage.
Qgil updated the task description. (Show Details)
Qgil added a project: Project-Admins.
Qgil added subscribers: Qgil, Aklapper, Jdlrobson and 2 others.
Aklapper triaged this task as Normal priority.Apr 27 2015, 11:11 AM
Deskana updated the task description. (Show Details)Apr 29 2015, 12:32 AM
Deskana set Security to None.
Deskana added a subscriber: Deskana.

I added my name to the list of people that think the existing process is overly cumbersome.

I think the current project creation process is way too lax. A lot of confusion is constantly added, making the usage of Phabricator more expensive.

Qgil added a comment.May 13 2015, 8:23 AM

What do you mean by 'too lax', and what would you propose to improve it?

I'm only considering the end result, i.e. the confusion mentioned above. I don't know whether the source of the issue resides in the process/policy, nor I have suggestions about it.

Nemo_bis removed a subscriber: Nemo_bis.May 13 2015, 9:09 AM
Aklapper claimed this task.Jun 1 2015, 11:42 AM
Aklapper added a project: ECT-June-2015.
Aklapper updated the task description. (Show Details)Jun 22 2015, 12:22 PM
Aklapper updated the task description. (Show Details)

Quim: Thanks for the great proposal.
I've made some smaller clarification edits to the task description but didn't change any bigger criteria.
I will put this into place and editing the mw.org page.

There is only one thing that I am still afraid of (but that does not block me from finishing this task): People creating projects with good intentions like "This projects allows us to categorize foo and bar" but "us" being a royal /we.
In short: Who is going to do the recurring gruntwork of going through tasks and associate the project to the tasks, and how would we find out if noone cares anymore about tagging those tasks? I imagine people who search for tasks in a project that they expect the results to be rather complete than empty, and if there was only one or two persons who cared about tagging tasks for a certain project and those people become inactive, we have no chance to find out. But as this should mostly cover the case of "Tag" projects I might be overthinking this.

https://phabricator.wikimedia.org/T95171 is an example where I am afraid.

Aklapper closed this task as Resolved.Jun 23 2015, 11:59 AM

Now reflected by the guidelines: https://www.mediawiki.org/w/index.php?title=Phabricator/Creating_and_renaming_projects&oldid=1687734

Closing as resolved. Thanks everybody for the feedback here!

Qgil added a comment.Jun 23 2015, 1:32 PM

Thank you!

I initially proposed to add a comment in a tracking task, and now this has morphed to create a new task anyways (the difference being that you can shoot first and then document). Let's see how this goes. The mental burden of adding a comment is a lot lesser than creating a new task...

Oh, I see. I admit I wasn't sure how to interpret your "add a comment" part.
So you propose a "New Phabricator project creations log" tracking bug with project creators adding comments added a la "I created the project #Foo-Bar"?

Qgil added a comment.Jun 23 2015, 3:51 PM

Exactly. Similar to T706.

So you propose a "New Phabricator project creations log" tracking bug

Makes a lot of sense, and way less complicated.

Created tracking bug T103700: LOG: Phabricator project creation and updated docs in https://www.mediawiki.org/w/index.php?title=Phabricator%2FCreating_and_renaming_projects&type=revision&diff=1689250&oldid=1689065

Now "resolved" for real. I hope.

Qgil awarded a token.Jun 24 2015, 8:54 PM